Attribute VB_Name = "modAUnzip"
Declare Function addUNZIP Lib "aunzip32.dll" () As Long
Declare Function addUNZIP_ArchiveName Lib "aunzip32.dll" (ByVal filename As String) As Integer
Declare Function addUNZIP_ExtractTo Lib "aunzip32.dll" (ByVal cPath As String) As Integer
Declare Function addUNZIP_Include Lib "aunzip32.dll" (ByVal files As String) As Integer
Declare Function addUNZIP_Overwrite Lib "aunzip32.dll" (ByVal iFlag As Integer) As Integer
Declare Function addUNZIP_RestoreStructure Lib "aunzip32.dll" (ByVal iFlag As Integer) As Integer
Declare Function addUNZIP_SetParentWindowHandle Lib "aunzip32.dll" (ByVal Hwnd As Long) As Integer
Declare Function addUNZIP_SetWindowHandle Lib "aunzip32.dll" (ByVal Hwnd As Long) As Integer
Declare Sub addUNZIP_Initialise Lib "aunzip32.dll" ()


Const azOVERWRITE_ALL = &HB
Const AM_UNZIPPING = &HE
Const AM_UNZIPPED = &HF
Const AM_ERROR = &H16

Public z As Integer
Function getAction(cFrom As String) As Integer
    getAction = Val(GetPiece(cFrom, "|", 2))
End Function
Function GetFileCompressedSize(cFrom As String) As Long
    GetFileCompressedSize = Val(GetPiece(cFrom, "|", 6))
End Function
Function GetFileCompressionRatio(cFrom As String) As Integer
    GetFileCompressionRatio = Val(GetPiece(cFrom, "|", 7))
End Function
Function GetFileName(cFrom As String) As String
    GetFileName = GetPiece(cFrom, "|", 4)
End Function
Function GetFileOriginalSize(cFrom As String) As Long
    GetFileOriginalSize = Val(GetPiece(cFrom, "|", 5))
End Function
Function GetPercentComplete(cFrom As String) As Integer
    GetPercentComplete = Val(GetPiece(cFrom, "|", 7))
End Function
Function GetPiece(from As String, delim As String, Index As Integer) As String
    Dim Temp$
    Dim Count As Integer
    Dim Where As Integer
    
    Temp$ = from & delim
    Where = InStr(Temp$, delim)
    Count = 0
    Do While (Where > 0)
        Count = Count + 1
        If (Count = Index) Then
            GetPiece = Left$(Temp$, Where - 1)
            Exit Function
        End If
        Temp$ = Right$(Temp$, Len(Temp$) - Where)
        Where = InStr(Temp$, delim)
    Loop
    If (Count = 0) Then
        GetPiece = from
    Else
        GetPiece = ""
    End If
End Function
Sub Raspakuj(sZip As String, cDestFolder As String)
    z = addUNZIP_Overwrite(azOVERWRITE_ALL)
    z = addUNZIP_ArchiveName(sZip)
    z = addUNZIP_Include("*.*") 'svi fajlovi
    z = addUNZIP_ExtractTo(cDestFolder)
    z = addUNZIP_RestoreStructure(False)
    z = addUNZIP()
End Sub
Sub PrikaciMe(F As Form, txtUnZip As Control)
On Error GoTo errH
     Call addUNZIP_Initialise
     z = addUNZIP_SetParentWindowHandle(F.Hwnd)
     z = addUNZIP_SetWindowHandle(txtUnZip.Hwnd)
errH:
End Sub
Function Akcija(nTip As Long) As String
    Select Case nTip
        Case AM_UNZIPPING: Akcija = "Raspakujem"
        Case AM_UNZIPPED: Akcija = "Raspakovano"
        Case AM_ERROR: Akcija = "Greka"
    End Select
End Function
