Attribute VB_Name = "modMain"
Public Type FILEINFO
    Name   As String
    Path   As String
    Run    As Integer
End Type
Public Files() As FILEINFO
Public fileCount As Integer
Public AppPath As String
Public showProgress As Integer
Public compresion As Long
Function generateINI() As String
'generise string koji ce biti snimljen kao INI fajl prilikom raspakivanja...
Dim i As Integer
generateINI = Trim$(CStr(fileCount)) & "|" & showProgress & "config.end" '[Config]

For i = 1 To fileCount
    generateINI = Trim$(generateINI) & frmMain.List1.List(i - 1) & "|" & _
                    Files(i).Path & "|" & Files(i).Run & "file.end"
Next
    generateINI = Trim$(generateINI)

End Function
Sub Compile(filename As String)
    Dim msgret As VbMsgBoxResult, i As Integer, fn As Integer
    Dim zipFile As String, dllFile As String, cfgFile As String
    Dim BeginPos As Long, PropBag As New PropertyBag, varTemp As Variant
    
    frmMain.Enabled = False
    
    If fileCount < 1 Then GoTo restore
    
    'proveravamo da li se template.ext nalazi u istom folderu kao i compiler
    If (Dir(AppPath & "template.ext") = "") Then
        MsgBox "template.ext not found!" & vbCrLf & _
            "Please reinstall application.", vbExclamation, "Error!"
        GoTo restore
    End If
    
    'proveravamo da li se aunzip32.dll nalazi u istom folderu kao i compiler
    If (Dir(AppPath & "aunzip32.dll") = "") Then
        MsgBox "aunzip32.dll not found !" & vbCrLf & _
            "Please reinstall application.", vbExclamation, "Error!"
        GoTo restore
    End If
    
    If (Dir(filename) <> "") Then 'output fajl vec postoji
        msgret = MsgBox("File:" & vbCrLf & filename & vbCrLf & _
        "already exists! Do you want to overwrite it?", _
        vbExclamation + vbYesNo, "[K] Installer Compiler")
        If msgret = vbNo Then
            GoTo restore
        Else
            On Error GoTo killerror
            Kill filename
            GoTo exitif
killerror:
        MsgBox "Error overwriting file:" & vbCrLf & filename & vbCrLf & _
                "Please select another name and try again.", _
                vbCritical, "[K] Installer Compiler"
            GoTo restore
        End If
    End If
exitif:

    If Dir(AppPath & "zipinst.tmp") <> "" Then
        On Error GoTo errh:
        Kill AppPath & "zipinst.tmp"
    End If
    
    frmMain.Caption = "[K] Installer Compiler - Compressing..."
    For i = 1 To fileCount
        Call Upakuj(AppPath & "zipinst.tmp", Files(i).Name, compresion)
    Next
    
    frmMain.Caption = "[K] Installer Compiler - Compiling..."
    'On Error GoTo errh
    
    fn = FreeFile
    Open AppPath & "zipinst.tmp" For Binary As #fn
        zipFile = Input(LOF(fn), #fn) 'ubacujemo ceo zip fajl u jedan string
    Close #fn
    Kill AppPath & "zipinst.tmp"
    
    fn = FreeFile
    Open AppPath & "aunzip32.dll" For Binary As #fn
        dllFile = Input(LOF(fn), #fn) 'ubacujemo ceo zip fajl u jedan string
    Close #fn
    
    cfgFile = generateINI 'generisemo cfg fajl
    
    frmMain.Caption = "[K] Installer Compiler - Writing EXE..."
    With PropBag
        .WriteProperty "zipFile", zipFile
        .WriteProperty "dllFile", dllFile
        .WriteProperty "cfgFile", cfgFile
    End With
    
    On Error GoTo errh
    FileCopy AppPath & "template.ext", filename
    
    varTemp = PropBag.Contents 'upisujemo propertybag u variant tip
    
    fn = FreeFile
    Open filename For Binary As #fn
        BeginPos = LOF(fn)       'odavde upisujemo podatke (na kraj)
                
        Seek #1, LOF(fn)
        Put #1, , varTemp   'upisujemo propertybag
        Put #1, , BeginPos
    
    Close #1
    
    MsgBox "Successfully compiled to" & vbCrLf & filename, vbInformation, _
                                                        "[K] Installer Compiler"
    GoTo restore
errh:
    MsgBox "Error: " & Err.Description, vbCritical, "Error: " & Err.Number
restore:
    frmMain.Enabled = True
    frmMain.Caption = "[K] Installer Compiler"
End Sub

